# dml-small-models
No description provided (generated by Openapi Generator https://github.com/openapitools/openapi-generator)

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 0.3.3
- Generator version: 7.10.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.8+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import electrificationutils
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import electrificationutils
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import electrificationutils
from electrificationutils.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = electrificationutils.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with electrificationutils.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = electrificationutils.GGRFHVACUpdateApi(api_client)
    electric_efficiency = electrificationutils.HvacEfficiencyElectricDetailed() # HvacEfficiencyElectricDetailed | 

    try:
        # Ggrf Hvac Upgrade Btu Per Watt Hour
        api_response = api_instance.ggrf_hvac_upgrade_btu_per_watt_hour(electric_efficiency)
        print("The response of GGRFHVACUpdateApi->ggrf_hvac_upgrade_btu_per_watt_hour:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling GGRFHVACUpdateApi->ggrf_hvac_upgrade_btu_per_watt_hour: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*GGRFHVACUpdateApi* | [**ggrf_hvac_upgrade_btu_per_watt_hour**](docs/GGRFHVACUpdateApi.md#ggrf_hvac_upgrade_btu_per_watt_hour) | **GET** /app/v1/ggrf/hvac_upgrade/btu_per_watt_hour/ | Ggrf Hvac Upgrade Btu Per Watt Hour
*GGRFHVACUpdateApi* | [**ggrf_hvac_upgrade_electric_to_electric**](docs/GGRFHVACUpdateApi.md#ggrf_hvac_upgrade_electric_to_electric) | **GET** /app/v1/ggrf/hvac_upgrade/electric_to_electric/ | Ggrf Hvac Upgrade Electric To Electric
*GGRFHVACUpdateApi* | [**ggrf_hvac_upgrade_fossil_to_electric**](docs/GGRFHVACUpdateApi.md#ggrf_hvac_upgrade_fossil_to_electric) | **GET** /app/v1/ggrf/hvac_upgrade/fossil_to_electric/ | Ggrf Hvac Upgrade Fossil To Electric
*HealthImpactsApi* | [**query_health_impacts**](docs/HealthImpactsApi.md#query_health_impacts) | **GET** /api/v1/health_impacts/ | Query Health Impacts
*RangeUpgradeApi* | [**range_upgrade**](docs/RangeUpgradeApi.md#range_upgrade) | **GET** /app/v1/range_upgrade/ | Range Upgrade


## Documentation For Models

 - [EnergyQuantity](docs/EnergyQuantity.md)
 - [EnergyTradeoff](docs/EnergyTradeoff.md)
 - [GroupBy](docs/GroupBy.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [HvacEfficiencyElectricDetailed](docs/HvacEfficiencyElectricDetailed.md)
 - [HvacEfficiencyFossilFuels](docs/HvacEfficiencyFossilFuels.md)
 - [HvacUpdateResults](docs/HvacUpdateResults.md)
 - [Metrics](docs/Metrics.md)
 - [RangeFuelType](docs/RangeFuelType.md)
 - [UpgradeOption](docs/UpgradeOption.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization

Endpoints do not require authorization.


## Author




